#ifndef GENERAL_H
#define GENERAL_H

typedef unsigned char u8;
typedef signed char s8;
typedef unsigned short int u16;
typedef signed short int s16;
typedef unsigned int u32;
typedef signed int s32;
typedef unsigned long long int u64;
typedef signed long long int s64;

//#define PACKED	#pragma pack(1)
#define printk	printf

#define PAGESIZE		4096
#define PAGEMASK		(PAGESIZE - 1)

#define ABS(x)			(x < 0 ? -x : x)
#define DIFF(a,b)		(ABS(a-b))

#define GSM_SIZE		0x20000000
#define GSM_START		0xc0000000
#define GSM_END			(GSM_START + GSM_SIZE)
#define PTD_START		0xBFC00000
#define PTD_END			0xC0000000
#define PTD_INDEX		0x000002FF
#define VMM_START		0x00001000
#define VMM_END			GSM_START
#define VMM_SIZE		(VMM_END - VMM_START)

#define	INVALID_OBJECT				0xffffffff

typedef enum _PAGE_FLAGS {
	PAGE_PRESENT = 0x00000001,
	PAGE_WRITEABLE = 0x00000002,
	PAGE_READ_ONLY = (PAGE_PRESENT | 0),
	PAGE_READ_WRITE = (PAGE_WRITEABLE | PAGE_PRESENT),
	PAGE_USER = 0x00000004,
	PAGE_RES1 = 0x00000008,
	PAGE_RES2 = 0x00000010,
	PAGE_ACCESSED = 0x00000020,
	PAGE_DIRTY = 0x00000040,
	PAGE_SIZE4M = 0x00000080,
	PAGE_GLOBAL = 0x00000100,
	PAGE_COPY_ON_WRITE = 0x00000200,
	PAGE_NON_PAGEABLE = 0x00000400
} PAGE_FLAGS;

#define MmPageAligned(x)			((x + PAGEMASK) & ~PAGEMASK)

#define CPU_AMD_K8

#if defined(CPU_AMD_K6)
	#define CPU_CACHE_LINE_SIZE 32
#elif defined(CPU_AMD_K7)
	#define CPU_CACHE_LINE_SIZE 64
#elif defined(CPU_AMD_K8)
	#define CPU_CACHE_LINE_SIZE 64
#elif defined(CPU_INTEL_P2)
	#define CPU_CACHE_LINE_SIZE 32
#elif defined(CPU_INTEL_P3)
	#define CPU_CACHE_LINE_SIZE 32
#elif defined(CPU_INTEL_P4)
	#define CPU_CACHE_LINE_SIZE 64
#else
	#define CPU_CACHE_LINE_SIZE 64
#endif

/* error codes */

typedef enum _ERROR_CODES {
	STATUS_SUCCESS = 0x00000000,
	STATUS_GENERAL = 0xf0000000,
	STATUS_INVALID_RANGE	= (STATUS_GENERAL + 0x00000001),
	STATUS_INVALID_ARGUMENT= (STATUS_GENERAL + 0x00000002),
	STATUS_INVALID_OPERATION = (STATUS_GENERAL + 0x00000003),
	STATUS_INVALID_POINTER = (STATUS_GENERAL + 0x00000004),
	STATUS_INVALID_ALIGNMENT = (STATUS_GENERAL + 0x00000006),
	STATUS_CORRUPTED_DATA = (STATUS_GENERAL + 0x00000007),
	STATUS_NO_MORE_MEMORY = (STATUS_GENERAL + 0x00001000)
} ERROR_CODES;

#endif
